/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dommanipulation;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class DOMManipulation {
    private static final String DOCUMENT_NAME="data.xml";
    private static final String RESULT_NAME ="data-out.xml";
    
    private Document doc;
    
    public void loadDocument() {
        try {
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder docBuilder = dbf.newDocumentBuilder();
            doc = docBuilder.parse(DOCUMENT_NAME);
        } catch (ParserConfigurationException | SAXException | IOException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
    }

    /**
     * Calculates and adds new element total into the element production with the total 
     * amount of products
     */
    
    public void calculateTotal() {
        int total = getTotal();
        
        setTotal(total);
    }
    
    /**
     * Calculates the average price of all products and adds it as a new atribute average_price 
     * to the element production
     */
    public void calculateAvg() {
        int total = getTotalPrice();
        int products = getProductsAmountNumber();
        double avg = (double)total/products;
        setAverage(avg);
        
    }

    public void saveDocument(){
        try {
            TransformerFactory tf = TransformerFactory.newInstance();
            Transformer transformer = tf.newTransformer();
            transformer.transform(new DOMSource(doc.getDocumentElement()),new StreamResult(new FileOutputStream(RESULT_NAME)));
        } catch (TransformerConfigurationException | FileNotFoundException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, "Error saving file.", ex);
        } catch (TransformerException ex) {
            Logger.getLogger(DOMManipulation.class.getName()).log(Level.SEVERE, "Error saving file.", ex);
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        DOMManipulation dom = new DOMManipulation();
        dom.loadDocument();
        dom.calculateTotal();
        dom.calculateAvg();
        dom.saveDocument();
    }

    private int getTotal() {
        int total = 0;
        NodeList amounts = doc.getElementsByTagName("amount");
        for(int i=0; i < amounts.getLength() ; i++){
            Element amountEl = (Element)amounts.item(i);
            int amount = Integer.parseInt(amountEl.getTextContent());
            total += amount;
        }
        return total;
    }

    private void setTotal(int total) {
        NodeList productions = doc.getElementsByTagName("production");
        Element totalElement = doc.createElement("total");
        totalElement.setTextContent(total+"");
        Element production = (Element) productions.item(0);
        production.appendChild(totalElement);
    }

    private int getProductsNumber() {
        NodeList productList = doc.getElementsByTagName("product");
        System.err.println(String.format("Pocet produktu: %d",productList.getLength()));
        return productList.getLength();
    }

    private void setAverage(double avg) {
        NodeList productionElements = doc.getElementsByTagName("production");
        Element production = (Element) productionElements.item(0);
        production.setAttribute("average_price", String.format("%.2f",avg));
    }

    private int getTotalPrice() {
        int totalPrice = 0;
        NodeList products = doc.getElementsByTagName("product");
        for(int i=0;i<products.getLength();i++) {
            Element product = (Element) products.item(i);
            Element priceEl = (Element) product.getElementsByTagName("price").item(0);
            Element amountEl = (Element) product.getElementsByTagName("amount").item(0);
            int price = Integer.parseInt(priceEl.getTextContent());
            int amount = Integer.parseInt(amountEl.getTextContent());
            totalPrice += price * amount;
        }
        return totalPrice;
    }

    private int getProductsAmountNumber() {
        NodeList amounts = doc.getElementsByTagName("amount");
        int total = 0;
        for(int i=0 ; i<amounts.getLength() ; i++){
            Element amountEl = (Element) amounts.item(i);
            int amount = Integer.parseInt(amountEl.getTextContent());
            total += amount;
        }
        return total;
    }

    
    
}
